"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
import typing
from PyQt5 import QtCore
from PyQt5.QtGui import *


class QExposeEvent(QtCore.QEvent):
    """
    https://doc.qt.io/qt-5/qexposeevent.html

    **Detailed Description**

    Expose events are sent to windows when an area of the window is invalidated,
    for example when window exposure in the windowing system changes.

    A Window with a client area that is completely covered by another window, or
    is otherwise not visible may be considered obscured by Qt and may in such
    cases not receive expose events.

    The event handler **QWindow::exposeEvent** () receives expose events.
    """

    @typing.overload
    def __init__(self, rgn: "QRegion") -> None:
        """
        https://doc.qt.io/qt-5/qexposeevent.html#QExposeEvent

        **QExposeEvent::QExposeEvent(const QRegion & exposeRegion )**

        Constructs an expose event for the given **exposeRegion** which must be
        in local coordinates.
        """
        ...

    @typing.overload
    def __init__(self, a0: "QExposeEvent") -> None:
        """
        https://doc.qt.io/qt-5/qexposeevent.html#QExposeEvent

        **QExposeEvent::QExposeEvent(const QRegion & exposeRegion )**

        Constructs an expose event for the given **exposeRegion** which must be
        in local coordinates.
        """
        ...

    def region(self) -> "QRegion":
        """
        https://doc.qt.io/qt-5/qexposeevent.html#region

        **const QRegion &QExposeEvent::region() const**

        Returns the window area that has been exposed. The region is given in
        local coordinates.
        """
        ...
