"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
import typing
from PyQt5.QtLocation import *


class QGeoRouteLeg(QGeoRoute):
    """
    https://doc.qt.io/qt-5/qgeorouteleg.html

    **Detailed Description**

    **Note:****QGeoRoute::routeLegs**  will return an empty list if called on a
    route leg.

    **See also** **QGeoRoute** .
    """

    @typing.overload
    def __init__(self) -> None:
        """
        https://doc.qt.io/qt-5/qgeorouteleg.html#QGeoRouteLeg

        **QGeoRouteLeg::QGeoRouteLeg()**

        Constructs a route leg object.
        """
        ...

    @typing.overload
    def __init__(self, other: "QGeoRouteLeg") -> None:
        """
        https://doc.qt.io/qt-5/qgeorouteleg.html#QGeoRouteLeg-1

        **QGeoRouteLeg::QGeoRouteLeg(const QGeoRouteLeg & other )**

        Constructs a route leg object from the contents of **other**.
        """
        ...

    def overallRoute(self) -> QGeoRoute:
        """
        https://doc.qt.io/qt-5/qgeorouteleg.html#overallRoute

        **QGeoRoute QGeoRouteLeg::overallRoute() const**

        Returns the route that contains this route leg.

        **See also** **setOverallRoute** ().
        """
        ...

    def setOverallRoute(self, route: QGeoRoute) -> None:
        """
        https://doc.qt.io/qt-5/qgeorouteleg.html#setOverallRoute

        **void QGeoRouteLeg::setOverallRoute(const QGeoRoute & route )**

        Sets the **route** that contains this route leg.

        **See also** **overallRoute** ().
        """
        ...

    def legIndex(self) -> int:
        """
        https://doc.qt.io/qt-5/qgeorouteleg.html#legIndex

        **int QGeoRouteLeg::legIndex() const**

        Returns the index of this route leg inside the containing
        **QGeoRoute::routeLegs**  list. Can be used to find the next legs.

        **See also** **setLegIndex** ().
        """
        ...

    def setLegIndex(self, idx: int) -> None:
        """
        https://doc.qt.io/qt-5/qgeorouteleg.html#setLegIndex

        **void QGeoRouteLeg::setLegIndex(int idx )**

        Sets the route leg index to **idx**.

        **See also** **legIndex** ().
        """
        ...
