"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
import PyQt5.sip


class QMediaMetaData(PyQt5.sip.simplewrapper):
    """
    https://doc.qt.io/qt-5/qmediametadata.html

    **Detailed Description**

    **Note:** Not all identifiers are supported on all platforms. Please consult
    vendor documentation for specific support on different platforms.

    Common attributes
    ValueDescriptionType
    TitleThe title of the
    media.**QString**
    SubTitleThe sub-title of the media.**QString**
    AuthorThe authors of the media.**QStringList**
    CommentA user comment about
    the media.**QString**
    DescriptionA description of the media.**QString**
    CategoryThe category of the media.**QStringList**
    GenreThe genre of the
    media.**QStringList**
    YearThe year of release of the media.int
    DateThe
    date of the media.**QDate** .
    UserRatingA user rating of the media.int
    [0..100]
    KeywordsA list of keywords describing the media.**QStringList**
    LanguageThe language of media, as an ISO 639-2 code.**QString**
    PublisherThe publisher of the media.**QString**
    CopyrightThe media's
    copyright notice.**QString**
    ParentalRatingThe parental rating of the
    media.**QString**
    RatingOrganizationThe organization responsible for the
    parental rating of the media.**QString**
    Media attributes
    SizeThe size
    in bytes of the media.qint64
    MediaTypeThe type of the media (audio, video,
    etc).**QString**
    DurationThe duration in millseconds of the media.qint64
    Audio attributes
    AudioBitRateThe bit rate of the media's audio stream in
    bits per second.int
    AudioCodecThe codec of the media's audio
    stream.**QString**
    AverageLevelThe average volume level of the media.int
    ChannelCountThe number of channels in the media's audio stream.int
    PeakValueThe peak volume of the media's audio stream.int
    SampleRateThe
    sample rate of the media's audio stream in hertz.int
    Music attributes
    AlbumTitleThe title of the album the media belongs to.**QString**
    AlbumArtistThe principal artist of the album the media belongs
    to.**QString**
    ContributingArtistThe artists contributing to the
    media.**QStringList**
    ComposerThe composer of the media.**QStringList**
    ConductorThe conductor of the media.**QString**
    LyricsThe lyrics to the
    media.**QString**
    MoodThe mood of the media.**QString**
    TrackNumberThe
    track number of the media.int
    TrackCountThe number of tracks on the album
    containing the media.int
    CoverArtUrlSmallThe URL of a small cover art
    image.**QUrl**
    CoverArtUrlLargeThe URL of a large cover art image.**QUrl**
    CoverArtImageAn embedded cover art image.**QImage**
    Image and video
    attributes
    ResolutionThe dimensions of an image or video.**QSize**
    PixelAspectRatioThe pixel aspect ratio of an image or video.**QSize**
    OrientationOrientation of an image or video.int (degrees)
    Video attributes
    VideoFrameRateThe frame rate of the media's video stream.qreal
    VideoBitRateThe bit rate of the media's video stream in bits per second.int
    VideoCodecThe codec of the media's video stream.**QString**
    PosterUrlThe
    URL of a poster image.**QUrl**
    PosterImageAn embedded poster
    image.**QImage**
    Movie attributes
    ChapterNumberThe chapter number of the
    media.int
    DirectorThe director of the media.**QString**
    LeadPerformerThe
    lead performer in the media.**QStringList**
    WriterThe writer of the
    media.**QStringList**
    Photo attributes.
    CameraManufacturerThe
    manufacturer of the camera used to capture the media.**QString**
    CameraModelThe model of the camera used to capture the media.**QString**
    EventThe event during which the media was captured.**QString**
    SubjectThe
    subject of the media.**QString**
    ExposureTimeExposure time, given in
    seconds.qreal
    FNumberThe F Number.int
    ExposureProgramThe class of the
    program used by the camera to set exposure when the picture is
    taken.**QString**
    ISOSpeedRatingsIndicates the ISO Speed and ISO Latitude
    of the camera or input device as specified in ISO 12232.qreal
    ExposureBiasValueThe exposure bias. The unit is the APEX (Additive System of
    Photographic Exposure) setting.qreal
    DateTimeOriginalThe date and time
    when the original image data was generated.**QDateTime**
    DateTimeDigitizedThe date and time when the image was stored as digital
    data.**QDateTime**
    SubjectDistanceThe distance to the subject, given in
    meters.qreal
    MeteringModeThe metering
    mode.**QCameraExposure::MeteringMode**
    LightSourceThe kind of light
    source.**QString**
    FlashStatus of flash when the image was
    shot.**QCameraExposure::FlashMode**
    FocalLengthThe actual focal length of
    the lens, in mm.qreal
    ExposureModeIndicates the exposure mode set when the
    image was shot.**QCameraExposure::ExposureMode**
    WhiteBalanceIndicates the
    white balance mode set when the image was
    shot.**QCameraImageProcessing::WhiteBalanceMode**
    DigitalZoomRatioIndicates the digital zoom ratio when the image was
    shot.qreal
    FocalLengthIn35mmFilmIndicates the equivalent focal length
    assuming a 35mm film camera, in mm.qreal
    SceneCaptureTypeIndicates the
    type of scene that was shot. It can also be used to record the mode in which
    the image was shot.**QString**
    GainControlIndicates the degree of overall
    image gain adjustment.qreal
    ContrastIndicates the direction of contrast
    processing applied by the camera when the image was shot.qreal
    SaturationIndicates the direction of saturation processing applied by the
    camera when the image was shot.qreal
    SharpnessIndicates the direction of
    sharpness processing applied by the camera when the image was shot.qreal
    DeviceSettingDescriptionExif tag, indicates information on the picture-
    taking conditions of a particular camera model.**QString**
    GPSLatitudeLatitude value of the geographical position (decimal degrees). A
    positive latitude indicates the Northern Hemisphere, and a negative latitude
    indicates the Southern Hemisphere.double
    GPSLongitudeLongitude value of
    the geographical position (decimal degrees). A positive longitude indicates
    the Eastern Hemisphere, and a negative longitude indicates the Western
    Hemisphere.double
    GPSAltitudeThe value of altitude in meters above sea
    level.double
    GPSTimeStampTime stamp of GPS data.**QDateTime**
    GPSSatellitesGPS satellites used for measurements.**QString**
    GPSStatusStatus of GPS receiver at image creation time.**QString**
    GPSDOPDegree of precision for GPS data.qreal
    GPSSpeedSpeed of GPS receiver
    movement in kilometers per hour.qreal
    GPSTrackDirection of GPS receiver
    movement. The range of values is [0.0, 360), with 0 direction pointing on
    either true or magnetic north, depending on GPSTrackRef.qreal
    GPSTrackRefReference for movement direction.**QChar** . 'T' means true
    direction and 'M' is magnetic direction.
    GPSImgDirectionDirection of image
    when captured.qreal The range of values is [0.0, 360).
    GPSImgDirectionRefReference for image direction.**QChar** . 'T' means true
    direction and 'M' is magnetic direction.
    GPSMapDatumGeodetic survey data
    used by the GPS receiver.**QString**
    GPSProcessingMethodThe name of the
    method used for location finding.**QString**
    GPSAreaInformationThe name of
    the GPS area.**QString**
    ThumbnailImageAn embedded thumbnail
    image.**QImage**
    """

    AlbumArtist: str = ...
    AlbumTitle: str = ...
    AudioBitRate: str = ...
    AudioCodec: str = ...
    Author: str = ...
    AverageLevel: str = ...
    CameraManufacturer: str = ...
    CameraModel: str = ...
    Category: str = ...
    ChannelCount: str = ...
    ChapterNumber: str = ...
    Comment: str = ...
    Composer: str = ...
    Conductor: str = ...
    Contrast: str = ...
    ContributingArtist: str = ...
    Copyright: str = ...
    CoverArtImage: str = ...
    CoverArtUrlLarge: str = ...
    CoverArtUrlSmall: str = ...
    Date: str = ...
    DateTimeDigitized: str = ...
    DateTimeOriginal: str = ...
    Description: str = ...
    DeviceSettingDescription: str = ...
    DigitalZoomRatio: str = ...
    Director: str = ...
    Duration: str = ...
    Event: str = ...
    ExposureBiasValue: str = ...
    ExposureMode: str = ...
    ExposureProgram: str = ...
    ExposureTime: str = ...
    FNumber: str = ...
    Flash: str = ...
    FocalLength: str = ...
    FocalLengthIn35mmFilm: str = ...
    GPSAltitude: str = ...
    GPSAreaInformation: str = ...
    GPSDOP: str = ...
    GPSImgDirection: str = ...
    GPSImgDirectionRef: str = ...
    GPSLatitude: str = ...
    GPSLongitude: str = ...
    GPSMapDatum: str = ...
    GPSProcessingMethod: str = ...
    GPSSatellites: str = ...
    GPSSpeed: str = ...
    GPSStatus: str = ...
    GPSTimeStamp: str = ...
    GPSTrack: str = ...
    GPSTrackRef: str = ...
    GainControl: str = ...
    Genre: str = ...
    ISOSpeedRatings: str = ...
    Keywords: str = ...
    Language: str = ...
    LeadPerformer: str = ...
    LightSource: str = ...
    Lyrics: str = ...
    MediaType: str = ...
    MeteringMode: str = ...
    Mood: str = ...
    Orientation: str = ...
    ParentalRating: str = ...
    PeakValue: str = ...
    PixelAspectRatio: str = ...
    PosterImage: str = ...
    PosterUrl: str = ...
    Publisher: str = ...
    RatingOrganization: str = ...
    Resolution: str = ...
    SampleRate: str = ...
    Saturation: str = ...
    SceneCaptureType: str = ...
    Sharpness: str = ...
    Size: str = ...
    SubTitle: str = ...
    Subject: str = ...
    SubjectDistance: str = ...
    ThumbnailImage: str = ...
    Title: str = ...
    TrackCount: str = ...
    TrackNumber: str = ...
    UserRating: str = ...
    VideoBitRate: str = ...
    VideoCodec: str = ...
    VideoFrameRate: str = ...
    WhiteBalance: str = ...
    Writer: str = ...
    Year: str = ...
