"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
import typing
import PyQt5.sip
from PyQt5.QtQml import *
from PyQt5 import sip


class QQmlImageProviderBase(PyQt5.sip.wrapper):
    """
    https://doc.qt.io/qt-5/qqmlimageproviderbase.html

    **Detailed Description**

    Image providers must be registered with the QML engine. The only information
    the QML engine knows about image providers is the type of image data they
    provide. To use an image provider to acquire image data, you must cast the
    QQmlImageProviderBase pointer to a **QQuickImageProvider**  pointer.

    **See also** **QQuickImageProvider**  and **QQuickTextureFactory** .
    """

    class Flag(int):
        ForceAsynchronousImageLoading: QQmlImageProviderBase = ...

    class ImageType(int):
        Image: QQmlImageProviderBase = ...
        Pixmap: QQmlImageProviderBase = ...
        Texture: QQmlImageProviderBase = ...
        ImageResponse: QQmlImageProviderBase = ...

    class Flags(sip.simplewrapper):
        @typing.overload
        def __init__(self) -> None:
            ...

        @typing.overload
        def __init__(
            self,
            f: typing.Union[
                "QQmlImageProviderBase.Flags", "QQmlImageProviderBase.Flag"
            ],
        ) -> None:
            ...

        @typing.overload
        def __init__(self, a0: "QQmlImageProviderBase.Flags") -> None:
            ...

        def __hash__(self) -> int:
            ...

        def __bool__(self) -> int:
            ...

        def __invert__(self) -> "QQmlImageProviderBase.Flags":
            ...

        def __index__(self) -> int:
            ...

        def __int__(self) -> int:
            ...

    def __init__(self, a0: "QQmlImageProviderBase") -> None:
        ...

    def flags(self) -> "QQmlImageProviderBase.Flags":
        """
        https://doc.qt.io/qt-5/qqmlimageproviderbase.html#flags

        **[pure virtual] QQmlImageProviderBase::Flags
        QQmlImageProviderBase::flags() const**

        Implement this to return the properties of this image provider.
        """
        ...

    def imageType(self) -> "QQmlImageProviderBase.ImageType":
        """
        https://doc.qt.io/qt-5/qqmlimageproviderbase.html#imageType

        **[pure virtual] QQmlImageProviderBase::ImageType
        QQmlImageProviderBase::imageType() const**

        Implement this method to return the image type supported by this image
        provider.
        """
        ...
