"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
import PyQt5.sip
from PyQt5 import QtGui
from PyQt5 import QtCore


class QQuickItemGrabResult(QtCore.QObject):
    """
    https://doc.qt.io/qt-5/qquickitemgrabresult.html

    **Detailed Description**

    **See also** **QQuickItem::grabToImage** ().
    """

    def event(self, a0: QtCore.QEvent) -> bool:
        ...

    def saveToFile(self, fileName: str) -> bool:
        """
        https://doc.qt.io/qt-5/qquickitemgrabresult.html#saveToFile

        **bool QQuickItemGrabResult::saveToFile(const QString & fileName )
        const**

        Saves the grab result as an image to **fileName**. Returns true if
        successful; otherwise returns false.

        **Note:** In Qt versions prior to 5.9, this function is marked as
        non-`const`.

        **Note:** This function can be invoked via the meta-object system and
        from QML. See **Q_INVOKABLE** .
        """
        ...

    def url(self) -> QtCore.QUrl:
        """
        https://doc.qt.io/qt-5/qquickitemgrabresult.html#url-prop

        **url : const QUrl**

        This property holds a URL which can be used in conjunction with URL
        based image consumers, such as the **QtQuick::Image**  type.

        The URL is valid until the **QQuickItemGrabResult**  object is deleted.

        The URL does not represent a valid file or location to read it from, it
        is primarily a key to access images through Qt Quick's image-based
        types.

        **Access functions:**

        QUrl **url** () const

        **Member Function Documentation**
        """
        ...

    def image(self) -> QtGui.QImage:
        """
        https://doc.qt.io/qt-5/qquickitemgrabresult.html#image-prop

        **image : const QImage**

        This property holds the pixel results from a grab.

        If the grab is not yet complete or if it failed, a null image is
        returned (`image.isNull()` will return `true`).

        **Access functions:**

        QImage **image** () const
        """
        ...

    @property
    def ready(self) -> PyQt5.QtCore.pyqtBoundSignal:
        """
        https://doc.qt.io/qt-5/qquickitemgrabresult.html#ready

        **[signal] void QQuickItemGrabResult::ready()**

        This signal is emitted when the grab has completed.
        """
        ...
