"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
import typing
import PyQt5.sip
from PyQt5 import QtCore
from PyQt5.QtSensors import *


class QTapSensor(QSensor):
    """
    https://doc.qt.io/qt-5/qtapsensor.html

    **Detailed Description**

    The only behavioural difference is that this class sets the type properly.

    This class also features a **reading** () function that returns a
    **QTapReading**  instead of a **QSensorReading** .

    For details about how the sensor works, see **QTapReading** .

    **See also** **QTapReading** .
    """

    def __init__(self, parent: typing.Optional[QtCore.QObject] = ...) -> None:
        """
        https://doc.qt.io/qt-5/qtapsensor.html#QTapSensor

        **QTapSensor::QTapSensor(QObject * parent = Q_NULLPTR)**

        Construct the sensor as a child of **parent**.
        """
        ...

    def setReturnDoubleTapEvents(self, returnDoubleTapEvents: bool) -> None:
        """
        https://doc.qt.io/qt-5/qtapsensor.html#returnDoubleTapEvents-prop

        **returnDoubleTapEvents : bool**

        This property holds a value indicating if double tap events should be
        reported.

        Set to true (the default) to have the sensor report only on double tap
        events. Set to false to have the sensor report only on individual tap
        events.

        It is not possible to have the sensor report both single and double tap
        events. If both are needed the app should create 2 sensor objects.

        The property must be set before calling **start** ().

        **Access functions:**

        bool **returnDoubleTapEvents** () const
        void
        **setReturnDoubleTapEvents** (bool **returnDoubleTapEvents** )

        **Notifier signal:**

        void **returnDoubleTapEventsChanged** (bool **returnDoubleTapEvents** )

        **Member Function Documentation**
        """
        ...

    def returnDoubleTapEvents(self) -> bool:
        """
        https://doc.qt.io/qt-5/qtapsensor.html#returnDoubleTapEvents-prop

        **returnDoubleTapEvents : bool**

        This property holds a value indicating if double tap events should be
        reported.

        Set to true (the default) to have the sensor report only on double tap
        events. Set to false to have the sensor report only on individual tap
        events.

        It is not possible to have the sensor report both single and double tap
        events. If both are needed the app should create 2 sensor objects.

        The property must be set before calling **start** ().

        **Access functions:**

        bool **returnDoubleTapEvents** () const
        void
        **setReturnDoubleTapEvents** (bool **returnDoubleTapEvents** )

        **Notifier signal:**

        void **returnDoubleTapEventsChanged** (bool **returnDoubleTapEvents** )

        **Member Function Documentation**
        """
        ...

    def reading(self) -> QTapReading:
        """
        https://doc.qt.io/qt-5/qtapsensor.html#reading

        **QTapReading *QTapSensor::reading() const**

        Returns the reading class for this sensor.

        **See also** **QSensor::reading** ().
        """
        ...

    @property
    def returnDoubleTapEventsChanged(self) -> PyQt5.QtCore.pyqtBoundSignal:
        ...
