"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
import typing
from PyQt5.QtWidgets import *


class QStyleOptionGroupBox(QStyleOptionComplex):
    """
    https://doc.qt.io/qt-5/qstyleoptiongroupbox.html

    **Detailed Description**

    **QStyleOptionButton**  contains all the information that **QStyle**
    functions need the various graphical elements of a group box.

    It holds the **lineWidth**  and the **midLineWidth**  for drawing the panel,
    the group box's **title**  and the title's **alignment**  and **color** .

    For performance reasons, the access to the member variables is direct (i.e.,
    using the `.` or `->` operator). This low-level feel makes the structures
    straightforward to use and emphasizes that these are simply parameters used
    by the style functions.

    For an example demonstrating how style options can be used, see the
    **Styles**  example.

    **See also** **QStyleOption** , **QStyleOptionComplex** , and **QGroupBox**
    .
    """

    class StyleOptionVersion(int):
        Version: QStyleOptionGroupBox = ...

    class StyleOptionType(int):
        Type: QStyleOptionGroupBox = ...

    features: typing = ...
    lineWidth: int = ...
    midLineWidth: int = ...
    text: str = ...
    textAlignment: typing = ...
    textColor: typing = ...

    @typing.overload
    def __init__(self) -> None:
        """
        https://doc.qt.io/qt-5/qstyleoptiongroupbox.html#QStyleOptionGroupBox

        **QStyleOptionGroupBox::QStyleOptionGroupBox()**

        Constructs a QStyleOptionGroupBox, initializing the members variables to
        their default values.
        """
        ...

    @typing.overload
    def __init__(self, other: "QStyleOptionGroupBox") -> None:
        """
        https://doc.qt.io/qt-5/qstyleoptiongroupbox.html#QStyleOptionGroupBox-1

        **QStyleOptionGroupBox::QStyleOptionGroupBox(const QStyleOptionGroupBox
        & other )**

        Constructs a copy of the **other** style option.
        """
        ...
