"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
import typing
from PyQt5 import QtCore
from PyQt5.QtWidgets import *
from PyQt5 import sip


class QStyleOptionToolBar(QStyleOption):
    """
    https://doc.qt.io/qt-5/qstyleoptiontoolbar.html

    **Detailed Description**

    QStyleOptionToolBar contains all the information that **QStyle**  functions
    need to draw **QToolBar** .

    For performance reasons, the access to the member variables is direct (i.e.,
    using the `.` or `->` operator). This low-level feel makes the structures
    straightforward to use and emphasizes that these are simply parameters used
    by the style functions.

    The QStyleOptionToolBar class holds the **lineWidth**  and the
    **midLineWidth**  for drawing the widget. It also stores information about
    which **area**  the toolbar should be located in, whether it is movable or
    not, which position the toolbar line should have (**positionOfLine** ), and
    the toolbar's position within the line (**positionWithinLine** ).

    In addition, the class provides a couple of enums: The **ToolBarFeature**
    enum is used to describe whether a toolbar is movable or not, and the
    **ToolBarPosition**  enum is used to describe the position of a toolbar
    line, as well as the toolbar's position within the line.

    For an example demonstrating how style options can be used, see the
    **Styles**  example.

    **See also** **QStyleOption** .
    """

    class ToolBarFeature(int):
        None_: QStyleOptionToolBar = ...
        Movable: QStyleOptionToolBar = ...

    class ToolBarPosition(int):
        Beginning: QStyleOptionToolBar = ...
        Middle: QStyleOptionToolBar = ...
        End: QStyleOptionToolBar = ...
        OnlyOne: QStyleOptionToolBar = ...

    class StyleOptionVersion(int):
        Version: QStyleOptionToolBar = ...

    class StyleOptionType(int):
        Type: QStyleOptionToolBar = ...

    class ToolBarFeatures(sip.simplewrapper):
        @typing.overload
        def __init__(self) -> None:
            ...

        @typing.overload
        def __init__(
            self,
            f: typing.Union[
                "QStyleOptionToolBar.ToolBarFeatures",
                "QStyleOptionToolBar.ToolBarFeature",
            ],
        ) -> None:
            ...

        @typing.overload
        def __init__(self, a0: "QStyleOptionToolBar.ToolBarFeatures") -> None:
            ...

        def __hash__(self) -> int:
            ...

        def __bool__(self) -> int:
            ...

        def __invert__(self) -> "QStyleOptionToolBar.ToolBarFeatures":
            ...

        def __index__(self) -> int:
            ...

        def __int__(self) -> int:
            ...

    features: typing = ...
    lineWidth: int = ...
    midLineWidth: int = ...
    positionOfLine = ...
    positionWithinLine = ...
    toolBarArea: QtCore = ...

    @typing.overload
    def __init__(self) -> None:
        """
        https://doc.qt.io/qt-5/qstyleoptiontoolbar.html#QStyleOptionToolBar

        **QStyleOptionToolBar::QStyleOptionToolBar()**

        Constructs a QStyleOptionToolBar, initializing the members variables to
        their default values.
        """
        ...

    @typing.overload
    def __init__(self, other: "QStyleOptionToolBar") -> None:
        """
        https://doc.qt.io/qt-5/qstyleoptiontoolbar.html#QStyleOptionToolBar-1

        **QStyleOptionToolBar::QStyleOptionToolBar(const QStyleOptionToolBar &
        other )**

        Constructs a copy of the **other** style option.
        """
        ...
