"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
import typing
import PyQt5.sip
from PyQt5.QtWinExtras import *


class QWinJumpListItem(PyQt5.sip.wrapper):
    """
    https://doc.qt.io/qt-5/qwinjumplistitem.html

    **Detailed Description**
    """

    class Type(int):
        Destination: QWinJumpListItem = ...
        Link: QWinJumpListItem = ...
        Separator: QWinJumpListItem = ...

    def __init__(self, type: "QWinJumpListItem.Type") -> None:
        """
        https://doc.qt.io/qt-5/qwinjumplistitem.html#QWinJumpListItem

        **QWinJumpListItem::QWinJumpListItem(QWinJumpListItem::Type type )**

        Constructs a QWinJumpListItem with the specified **type**.
        """
        ...

    def arguments(self) -> typing.List[str]:
        """
        https://doc.qt.io/qt-5/qwinjumplistitem.html#arguments

        **QStringList QWinJumpListItem::arguments() const**

        Returns the command-line arguments of this item.

        **See also** **setArguments** ().
        """
        ...

    def setArguments(self, arguments: typing.Iterable[str]) -> None:
        """
        https://doc.qt.io/qt-5/qwinjumplistitem.html#setArguments

        **void QWinJumpListItem::setArguments(const QStringList & arguments )**

        Sets command-line **arguments** for this item.

        This value is used only if the type of this item is
        **QWinJumpListItem::Link** .

        **See also** **arguments** () and **setFilePath** ().
        """
        ...

    def description(self) -> str:
        """
        https://doc.qt.io/qt-5/qwinjumplistitem.html#description

        **QString QWinJumpListItem::description() const**

        Returns the description of this item.

        **See also** **setDescription** ().
        """
        ...

    def setDescription(self, description: str) -> None:
        """
        https://doc.qt.io/qt-5/qwinjumplistitem.html#setDescription

        **void QWinJumpListItem::setDescription(const QString & description )**

        Sets a **description** for this item.

        This value is used only if the type of this item is
        **QWinJumpListItem::Link** .

        **See also** **description** ().
        """
        ...

    def title(self) -> str:
        """
        https://doc.qt.io/qt-5/qwinjumplistitem.html#title

        **QString QWinJumpListItem::title() const**

        Returns the title of this item.

        **See also** **setTitle** ().
        """
        ...

    def setTitle(self, title: str) -> None:
        """
        https://doc.qt.io/qt-5/qwinjumplistitem.html#setTitle

        **void QWinJumpListItem::setTitle(const QString & title )**

        Sets the **title** of this item.

        This value is used only if the type of this item is
        **QWinJumpListItem::Link** .

        **See also** **title** ().
        """
        ...

    def icon(self) -> QtGui.QIcon:
        """
        https://doc.qt.io/qt-5/qwinjumplistitem.html#icon

        **QIcon QWinJumpListItem::icon() const**

        Returns the icon set for this item.

        **See also** **setIcon** ().
        """
        ...

    def setIcon(self, icon: QtGui.QIcon) -> None:
        """
        https://doc.qt.io/qt-5/qwinjumplistitem.html#setIcon

        **void QWinJumpListItem::setIcon(const QIcon & icon )**

        Sets the **icon** of this item.

        This value is used only if the type of this item is
        **QWinJumpListItem::Link** .

        **See also** **icon** ().
        """
        ...

    def workingDirectory(self) -> str:
        """
        https://doc.qt.io/qt-5/qwinjumplistitem.html#workingDirectory

        **QString QWinJumpListItem::workingDirectory() const**

        Returns the working directory path.

        **See also** **setWorkingDirectory** ().
        """
        ...

    def setWorkingDirectory(self, workingDirectory: str) -> None:
        """
        https://doc.qt.io/qt-5/qwinjumplistitem.html#setWorkingDirectory

        **void QWinJumpListItem::setWorkingDirectory(const QString &
        workingDirectory )**

        Sets the path to the working directory of this item to
        **workingDirectory**.

        This value is used only if the type of this item is
        **QWinJumpListItem::Link** .

        **See also** **workingDirectory** () and **setFilePath** ().
        """
        ...

    def filePath(self) -> str:
        """
        https://doc.qt.io/qt-5/qwinjumplistitem.html#filePath

        **QString QWinJumpListItem::filePath() const**

        Returns the file path set by **setFilePath** ().

        **See also** **setFilePath** ().
        """
        ...

    def setFilePath(self, filePath: str) -> None:
        """
        https://doc.qt.io/qt-5/qwinjumplistitem.html#setFilePath

        **void QWinJumpListItem::setFilePath(const QString & filePath )**

        Sets the item **filePath** , the meaning of which depends on the type of
        this item:

        * If the item type is **QWinJumpListItem::Destination** , **filePath**
        is the path to a file that can be opened by an application.
          * If the
        item type is **QWinJumpListItem::Link** , **filePath** is the path to an
        executable that is executed when this item is clicked by the user.

        **See also** **filePath** (), **setWorkingDirectory** (), and
        **setArguments** ().
        """
        ...

    def type(self) -> "QWinJumpListItem.Type":
        """
        https://doc.qt.io/qt-5/qwinjumplistitem.html#type

        **QWinJumpListItem::Type QWinJumpListItem::type() const**

        Returns the item type.

        **See also** **setType** ().
        """
        ...

    def setType(self, type: "QWinJumpListItem.Type") -> None:
        """
        https://doc.qt.io/qt-5/qwinjumplistitem.html#setType

        **void QWinJumpListItem::setType(QWinJumpListItem::Type type )**

        Sets the item **type**.

        **See also** **type** ().
        """
        ...
